﻿using System;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Windows.Forms;

namespace WinGrid_FullSizeBitmap
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();

			this.ultraGrid1.DataSource = GetEmployees();
		}

		private void button1_Click(object sender, EventArgs e)
		{
			SaveFileDialog dialog = new SaveFileDialog();
			dialog.FileName = "GridImage.jpg";
			dialog.Filter = "Images|*.jpg";
			if (dialog.ShowDialog() == DialogResult.OK)
			{
				const int BUFFER = 30;
				//	Store the normal display height of the grid.
				int displayHeight = this.ultraGrid1.Height;
				//	Calculate height needed for all of the rows + headers/caption/etc...
				int imageHeight = this.ultraGrid1.Rows.Count * this.ultraGrid1.Rows[0].Height + BUFFER;
				//	Set the new height of the grid.
				this.ultraGrid1.Height = imageHeight;

				//	Save our image.
				Bitmap bmp = new Bitmap(this.ultraGrid1.Width, imageHeight);
				this.ultraGrid1.DrawToBitmap(bmp, this.ultraGrid1.DisplayRectangle);
				bmp.Save(dialog.FileName, ImageFormat.Jpeg);

				//	Set the height back to it's normal display height.
				this.ultraGrid1.Height = displayHeight;
			}
		}

		#region TestData
		private DataTable GetEmployees(int count = 24)
		{
			DataTable dtData = new DataTable("Employees");

			dtData.Columns.Add("EmployeeID", typeof(int));
			dtData.Columns.Add("Name", typeof(string));
			dtData.Columns.Add("OnSite", typeof(bool));
			dtData.Columns.Add("DateOfHire", typeof(DateTime));
			dtData.Columns.Add("Department", typeof(int));

			for (int i = 0; i < count; i++)
			{
				dtData.Rows.Add(new object[] { i, string.Format("Name {0}", i), (i % 2 == 0), DateTime.Today.Date.AddDays(-1 * i), i % 8 });
			}

			dtData.PrimaryKey = new DataColumn[] { dtData.Columns["EmployeeID"] };

			return dtData;
		}
		#endregion
	}
}
